searchNodes=[{"doc":"RefData is a library for Phoenix projects that lets you provide reference data for your forms (e.g. Gender) without using a database table. It has been written as tool for POC development but can be used in PROD for fields that are common for all Users and do not form part of complex queries.","ref":"RefData.html","title":"RefData","type":"behaviour"},{"doc":"Returns a list of data for the provided key. If the json defines grouped data it will return grouped data.Examplesiex(1)&gt; MyRefData.get(&quot;gender&quot;) [ [key: &quot;Male&quot;, value: &quot;male&quot;], [key: &quot;Female&quot;, value: &quot;female&quot;], [key: &quot;Non-binary&quot;, value: &quot;non-binary&quot;] ] iex(1)&gt; MyRefData.get(&quot;countries&quot;) [ Asia: [ [key: &quot;Australia&quot;, value: &quot;australia&quot;], [key: &quot;New Zealand&quot;, value: &quot;new zealand&quot;] ], Americas: [ [key: &quot;Canada&quot;, value: &quot;canada&quot;], [key: &quot;USA&quot;, value: &quot;usa&quot;]] ]","ref":"RefData.html#c:get/1","title":"RefData.get/1","type":"callback"},{"doc":"You can pass params to the get function. Keywords available:raw - Will return the raw data stored by RefDatadisabled: [] - Will return the data with the listed fields disabledExamples iex(1)&gt; MyRefData.get( &quot;gender&quot;, :raw) [{ &quot;gender&quot;: [&quot;Male&quot;, &quot;Female&quot;, &quot;Non-binary&quot;] } ] iex(1)&gt; MyRefData.get(&quot;gender&quot;, disabled: [&quot;Female&quot;]) [[key: &quot;Male&quot;, value: &quot;male&quot;], [key: &quot;Female&quot;, value: &quot;female&quot;, disabled: true], [key: &quot;Non-binary&quot;, value: &quot;non-binary&quot;] ]","ref":"RefData.html#c:get/2","title":"RefData.get/2","type":"callback"},{"doc":"Returns a list of all key values from the underlying data store. It will match the keys used in the individual json filesExamplesiex&gt; RefData.list_all_keys() [&quot;key1&quot;, &quot;key2&quot;]","ref":"RefData.html#c:list_all_keys/0","title":"RefData.list_all_keys/0","type":"callback"},{"doc":"","ref":"RefData.Server.html","title":"RefData.Server","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"RefData.Server.html#child_spec/1","title":"RefData.Server.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"RefData.Server.html#init/1","title":"RefData.Server.init/1","type":"function"},{"doc":"","ref":"RefData.Server.html#start_link/2","title":"RefData.Server.start_link/2","type":"function"},{"doc":"RefData RefData is a library for Phoenix projects that lets you provide reference data for your forms (e.g. Gender) without using a database table. It has been written as tool for POC development but can be used in PROD for fields that are common for all Users and do not form part of complex queries.","ref":"readme.html","title":"RefData","type":"extras"},{"doc":"The package can be installed by adding ref_data to your list of dependencies in mix.exs:def deps do [ {:ref_data, &quot;~&gt; X.X.X&quot;} ] end","ref":"readme.html#installation","title":"RefData - Installation","type":"extras"},{"doc":"RefData defaults to looking for json objects at the root of the project in a directory called ref_data. You can customise the path to your data by adding an entry in your config.exs file.use Mix.Config ... config :ref_data, path: &quot;path_to_your_dir (e.g. data)&quot; ...","ref":"readme.html#config","title":"RefData - Config","type":"extras"},{"doc":"The data is defined as json objects using a key and a list of values.{ &quot;gender&quot;: [ &quot;Male&quot;, &quot;Female&quot;, &quot;Non-binary&quot; ] }You can also define grouped data by creating a list of key value pairs of data.{ &quot;countries_grouped&quot;: [ { &quot;Asia&quot;: [&quot;Australia&quot;, &quot;New Zealand&quot;]}, { &quot;Americas&quot;: [&quot;Canada&quot;, &quot;USA&quot;]} ] }","ref":"readme.html#defining-data","title":"RefData - Defining Data","type":"extras"},{"doc":"Assuming you use RefData in a module named MyApp.MyRefData your API is:MyRefData.list_all_keys/0 It will list all keys for data held in memoryiex(1)&gt; MyRefData.list_all_keys [&quot;months&quot;, &quot;gender&quot;]MyRefData.get/1 When given a key it will return a list of data in the format required by Phoenix.HTML.select. If the json defines grouped data it will return the appropriate format.iex(1)&gt; MyRefData.get(&quot;gender&quot;) [ [key: &quot;Male&quot;, value: &quot;male&quot;], [key: &quot;Female&quot;, value: &quot;female&quot;], [key: &quot;Non-binary&quot;, value: &quot;non-binary&quot;] ]iex(1)&gt; MyRefData.get(&quot;countries&quot;) [ Asia: [ [key: &quot;Australia&quot;, value: &quot;australia&quot;], [key: &quot;New Zealand&quot;, value: &quot;new zealand&quot;] ], Americas: [ [key: &quot;Canada&quot;, value: &quot;canada&quot;], [key: &quot;USA&quot;, value: &quot;usa&quot;]] ]MyRefData.get/2When given a key and a switch you are able to disable data by passing in a list of values to disable. You can also pass in :raw and get back the data directly from memory.iex(1)&gt; MyRefData.get(&quot;gender&quot;, disabled: [&quot;Female&quot;]) [ [key: &quot;Male&quot;, value: &quot;male&quot;], [key: &quot;Female&quot;, value: &quot;female&quot;, disabled: true], [key: &quot;Non-binary&quot;, value: &quot;non-binary&quot;] ]iex(1)&gt; MyRefData.get(&quot;gender&quot;, :raw) [ { &quot;gender&quot;: [&quot;Male&quot;, &quot;Female&quot;, &quot;Non-binary&quot;] } ]","ref":"readme.html#using-refdata","title":"RefData - Using RefData","type":"extras"}]